#![allow(non_snake_case)]

#[macro_use]
extern crate zkp;

use curve25519_dalek::ristretto::RistrettoPoint;
use curve25519_dalek::scalar::Scalar;

use cmz::ggm::CMZ_A;
use cmz::ggm::CMZ_B;
use cmz::ggm::Issuer;

#[test]
fn create_issuer() {
    let i0 = Issuer::new(0);
    println!("i0 = {:?}", i0);
    let i1 = Issuer::new(1);
    println!("i1 = {:?}", i1);
}

#[test]
fn generator_test() {
    use hex_fmt::HexFmt;

    let A : &RistrettoPoint = &CMZ_A;
    let B : &RistrettoPoint = &CMZ_B;
    let two = Scalar::one() + Scalar::one();
    println!("A = {}", HexFmt(A.compress().to_bytes()));
    println!("B = {}", HexFmt(B.compress().to_bytes()));
    println!("2*A = {}", HexFmt((two*A).compress().to_bytes()));
    println!("2*A = {}", HexFmt((A+A).compress().to_bytes()));
    println!("2*B = {}", HexFmt((two*B).compress().to_bytes()));
    println!("2*B = {}", HexFmt((B+B).compress().to_bytes()));
}
